# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.action import Action
from ...commons.types.environment_id import EnvironmentId
from ...commons.types.space_id import SpaceId
from ...commons.types.workbook_id import WorkbookId
from ...sheets.types.sheet import Sheet
from .workbook_config_settings import WorkbookConfigSettings

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Workbook(pydantic.BaseModel):
    """
    A collection of one or more sheets
    """

    id: WorkbookId
    name: typing.Optional[str]
    space_id: SpaceId = pydantic.Field(alias="spaceId")
    environment_id: EnvironmentId = pydantic.Field(alias="environmentId")
    sheets: typing.Optional[typing.List[Sheet]]
    labels: typing.Optional[typing.List[str]]
    actions: typing.Optional[typing.List[Action]]
    settings: typing.Optional[WorkbookConfigSettings]
    metadata: typing.Optional[typing.Any] = pydantic.Field(description="Metadata for the workbook")
    namespace: typing.Optional[str]
    updated_at: dt.datetime = pydantic.Field(alias="updatedAt", description="Date the workbook was last updated")
    created_at: dt.datetime = pydantic.Field(alias="createdAt", description="Date the workbook was created")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
